
var currentAttachmentID;
function refreshDisplay(refreshType){
    var row, container, pageHeader, sideWell, pageFooter, headerArea;

    $('#refresh-section').remove();
    // $('div#insert').attr("class", "container");
    row = document.createElement("div");
    row.setAttribute("class", "row");
    row.setAttribute("id", "refresh-section");
    $('div#insert').append(row);

    container = document.createElement("div");
    container.setAttribute("class", "col-xs-9");
    row.appendChild(container);

    pageHeader = document.createElement("div");
    pageHeader.setAttribute("class", "page-header");
    pageHeader.setAttribute("tabindex", "0");
    container.appendChild(pageHeader);

	headerArea = $('div.page-header');
	headerArea.empty();

    if(refreshType == "Facility"){
        headerBuilder("Sites", headerArea);
        sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items"), null, function(returnedFacilities){
            container.appendChild(facilityDisplay(returnedFacilities.d.results));

            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "progress-container");
            container.appendChild(pageFooter);
            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "button-container");
            container.appendChild(pageFooter);

            progressBuilder();    
        });     
    }else if(refreshType == "Personnel"){
        headerBuilder("Personnel", headerArea);
        sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(groupJSON){
			var currentGroups = groupJSON.d.results;
			var siteUsersGroupID = -1;
			
	        for(var i=0; i<currentGroups.length; i++){ //find the site users' group for the user's site
	            if(currentGroups[i].Title.indexOf("Users") > -1){
	                siteUsersGroupID = currentGroups[i].Id;
	            }
	        }
	        
	        //perform REST calls if we found site users group
	        if(siteUsersGroupID > 0){ //assuming user belongs to only one site
				sendREST("GET", siteUrl.concat("_api/Web/SiteGroups("+siteUsersGroupID+")/Users"), null, function(siteUsers){
						sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(studyMembers){
			                container.appendChild(personnelDisplay(studyMembers, siteUsers));
			                //container.appendChild(editPersonnelDisplay());
			
			                pageFooter = document.createElement("div");
			                pageFooter.setAttribute("class", "progress-container");
			                container.appendChild(pageFooter);
			                pageFooter = document.createElement("div");
			                pageFooter.setAttribute("class", "button-container");
			                container.appendChild(pageFooter);
			
			                progressBuilder();
			                $("[value='Save Progress']").attr("onclick", "insertPerson()");
			                //$("[value='Save Progress']").attr("onkeypress", "insertPerson()");
						});
				});
	        }
       });
        
    }else if(refreshType == "Files"){
        headerBuilder("Attachments", headerArea);

        sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files?$expand=ListItemAllFields"), null, function(returnedFiles){
            //attachments = filterChecklists(returnedFiles.d.results, "-RAMS-");
			attachments = returnedFiles.d.results;
            container.appendChild(attachmentsDisplay(attachments));

            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "progress-container");
            container.appendChild(pageFooter);
            pageFooter = document.createElement("div");
            pageFooter.setAttribute("class", "button-container");
            container.appendChild(pageFooter);

            progressBuilder();            
        });
    }

    sideWell = document.createElement("div");
    sideWell.setAttribute("class", "col-xs-3 toolbar");
    row.appendChild(sideWell);

    sideColumnBuilder(null);
};

function personnelDisplay(studyMembers, siteUsers){
    var container, table, tableDiv, tbody, trow, skipFlag, cell, buttonID;

     // var selectUsers = [];
    // var tempList = ramsUsers.values();
    //******************************** NEED THIS TO WORK OFF OF A SP USER GROUP

    // //not including users who are already in the table and are active
    // for(var i=0; i<tableUsers.length; i++){
    //     skipFlag = false;
    //     for(var j=0; j<returnedMembers.length; j++){
    //         if((tableUsers[i].displayName == returnedMembers[j].user.displayName) && (returnedMembers[j].memberRole != "RAMS Reviewer")/*&&(returnedMembers[j].activeMember)*/){
    //             skipFlag = true;
    //         }
    //     }
    //     if(!skipFlag)
    //         selectUsers.push(tableUsers[i].displayName);
    // }

    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
    table = tableHeaderHelper("Personnel", [/*"VA",*/ "Name", "Study Team?", "Role", "COI Required?", "Edit Study?", "Purpose", "Notify?", "Update"]);
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");

    /*Table Body*/
    tbody = document.createElement("tbody");

    /*first row*/
    // trow = document.createElement("tr");
    // //not va
    // trow.appendChild(checkboxCellHelper("initVA", "Is Person not in VA", "swapForNonVA('initVA', 'initPerson')"));
    // //blank space
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(selectCellHelper("initPerson", "Select Person to Add", ["Please Select a User"].concat(selectUsers), null));
    // //study team
    // trow.appendChild(checkboxCellHelper("initStudyTeam", "Is Person on Study Team", null));
    // //blank space//role
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(selectCellHelper("initPersonRole", "Person's Role", ["Principal Investigator", "Clinical Coordinator", "Contractor"], null));
    // //COI required
    // trow.appendChild(checkboxCellHelper("initCOIReq", "Does Person Require COI", null));
    // //write permissions
    // trow.appendChild(checkboxCellHelper("initWritePerm", "Does Person have Write Permissions", null));
    // //explination
    // trow.appendChild(textCellHelper("td", ""));
    // //trow.appendChild(textareaCellHelper("td", "initExplanation", "Explination of Person"));
    // //notifications
    // trow.appendChild(checkboxCellHelper("initNotify", "Does Person want notifications", null));
    // //add/remove
    // //trow.appendChild(buttonCellHelper("Add", "insertPerson()"));
    // trow.appendChild(textCellHelper("td", ""));

    // tbody.appendChild(trow);

    // /*Second row*/
    // trow = document.createElement("tr");

    // //blank
    // trow.appendChild(textCellHelper("td", ""));

    // //name
    // cell = selectCellHelper("initPerson", "Select Person to Add", ["Please Select a User"].concat(selectUsers), null);
    // cell.setAttribute("colspan", "2");
    // trow.appendChild(cell);

    // //role
    // cell = selectCellHelper("initPersonRole", "Person's Role", ["Please Select a Role", "Clinical Coordinator", "Contractor", "Scientist"], null)
    // cell.setAttribute("colspan", "2");
    // trow.appendChild(cell);

    // //purpose
    // cell = textareaCellHelper("td", "initExplanation", "Explination of Person");
    // cell.setAttribute("colspan", "3");
    // trow.appendChild(cell);

    // //add person
    // trow.appendChild(buttonCellHelper("Add", "insertPerson()"));

    // tbody.appendChild(trow);

   for(var i=0; i<studyMembers.length; i++){
	    buttonID = "update"+i;	   
        
	    trow = document.createElement("tr");
        trow.setAttribute("tabindex", "0");

        //non VA
        //trow.appendChild(returnChecked(returnedMembers[i].vaUser));
        //name
        trow.appendChild(textCellHelper("td", studyMembers[i].user.displayName));
        //study team
        trow.appendChild(returnChecked(studyMembers[i].teamMember));
        //role
        trow.appendChild(textCellHelper("td", studyMembers[i].memberRole));
        //coi required
        trow.appendChild(returnChecked(studyMembers[i].coiRequired));
        //write permissions
        trow.appendChild(returnChecked(studyMembers[i].writePermissions));
        //explination
        trow.appendChild(textCellHelper("td", studyMembers[i].explaination));
        //notifications
        trow.appendChild(returnChecked(studyMembers[i].notifications));
        //remove
        // if(returnedMembers[i].activeMember == true){
        //     trow.appendChild(buttonCellHelper("Deactivate", "deactivateUser('"+returnedMembers[i].user.usersID+"')"));
        // }else{
        //     trow.appendChild(buttonCellHelper("Activate", "activateUser('"+returnedMembers[i].user.usersID+"')"));
        // }
        //console.log("member: "+ returnedMembers[i].user.displayName + " with role: " + returnedMembers[i].memberRole);
		if((studyMembers[i].memberRole == "Principal Investigator") || (studyMembers[i].memberRole == "Co-Principal Investigator")){ 
	        trow.appendChild(buttonCellHelper("Update", "updatePerson('"+studyMembers[i].user.displayName+"')", buttonID, true)); //disable update button for PI and CoPI
		}else{ 
	        trow.appendChild(buttonCellHelper("Update", "updatePerson('"+studyMembers[i].user.displayName+"')", buttonID)); //leave update button enabled
		}
        tbody.appendChild(trow);
    }

    table.appendChild(tbody);
    tableDiv.appendChild(table);
    //adding in the edit questions for the rows in the table
    //tableDiv.appendChild(editPersonnelDisplay(returnedMembers, tableUsers));
    container.appendChild(tableDiv);
    container.appendChild(editPersonnelDisplay(studyMembers, siteUsers));
    return container;
}

function buildUsernameList(JSON){
	var tempList = [];
	for(var i=0; i<JSON.d.results.length; i++){
		tempList.push(JSON.d.results[i].Title);
	}
	return tempList;
}

function editPersonnelDisplay(studyMembers, siteUsers){
    var container;
    var selectUsers = []; //contains final list of site users for drop down
    var skipPerson;

    container = document.createElement("div");
    container.setAttribute("class", "form-content");
    
    var nameIndex, skipPerson;
    var studyMemberNames = [];
    var siteUserNames = buildUsernameList(siteUsers); //create array from siteUsers JSON data
    
    /*add all study member display names to list*/
	for(var i=0; i<studyMembers.length; i++){
		studyMemberNames.push(studyMembers[i].user.displayName);
	}
	/*add site users to selectUsers array (based on role)*/
	for(var j=0; j<siteUserNames.length; j++){ 
		nameIndex = studyMemberNames.indexOf(siteUserNames[j]); //check if site user is on the study member list
		if(nameIndex > -1){ //user is on the study member list
			skipPerson = false;
			if((studyMembers[nameIndex].memberRole == "RAMS Reviewer") || (studyMembers[nameIndex].memberRole == "Principal Investigator") || (studyMembers[nameIndex].memberRole == "Co-Principal Investigator")){
				skipPerson = true;
			}
			if(!skipPerson){ //if study member is not a reviewer, PI or Co-PI
				selectUsers.push(siteUserNames[j]);
			}
		}else{ //user is not on the study member list
			selectUsers.push(siteUserNames[j]);
		}
	}
    
    //need to capture how many pixels each row takes up, then we want to change the height of div-table-content-big
    //to reflect how much room the table actually

    //container.appendChild(radioFieldHelper("initVA", "Is the person you are adding in the VA?", ["Yes", "No"]));
    container.appendChild(selectFieldHelper("initPerson", "Select a user to add or update:", ["Please Select a User"].concat(selectUsers), "updatePerson()"));
    container.appendChild(radioFieldHelper("initStudyTeam", "Is this user on your study team?", ["Yes", "No"]));
    container.appendChild(selectFieldHelper("initPersonRole", "What role will this user play?", ["Investigator","Co-Investigator","Sub-Investigator","Biostatistician","Clinical Coordinator","Collaborator","CSP Program Manager","Data Manager","Lab Manager","Lab Technician","National Study Coordinator","Nurse Assessor","Pharmacist","Pharmacy Technician","Regulatory Coordinator","Research Assistant","Research Nurse","Statistician","Study Coordinator"]));
    container.appendChild(radioFieldHelper("initCOIReq", "Does this user have a Conflict of Interest?", ["Yes", "No"]));
    container.appendChild(radioFieldHelper("initWritePerm", "Do you want this user to be able to edit your application?", ["Yes", "No"]));
    container.appendChild(textFieldHelper("initExplanation", "If needed, please elaborate on the user being added."));
    container.appendChild(radioFieldHelper("initNotify", "Do you want this user to recieve notifications pertaining to this study?", ["Yes", "No"]));
    container.appendChild(radioFieldHelper("initActivate", "Do you want to give this user access to your application?", ["Yes", "No"]));

    return container;
};

function attachmentsDisplay(returnedFiles){
    var container, link, paragraph, text; 
    var table, tableDiv, tbody, trow, dateAdded, cell;

    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
//    if(readOnlyState == false){
//        table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type", "Remove"]);
//    }else{
//        table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type"]);
//    }
    /*Add link to template*/
    paragraph = document.createElement("P");
    text = document.createTextNode("Click the link to download the ");
    
    link = document.createElement("A");
    link.href = "https://DNS  sqa.ram.msp.DNS   /sites/IRBApplications/FormTemplates/VHA%20form%2010-0493_Authorization%20for%20Use%20%20Release%20of%20IIHI%20for%20VHA%20Research%20(9-2015).pdf";
    link.target = "_blank"; //open document in new window or tab
    link.innerHTML = "HIPAA Template";
    
    paragraph.appendChild(text);
    paragraph.appendChild(link);
    container.appendChild(paragraph);
    
    table = tableHeaderHelper("Current Attachments", ["Attachment", "Date Added", "Version", "Status", "Date Approved", "Document Type", "Remove", "Update"]);
    
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body*/
    tbody = document.createElement("tbody");
    
    for(var i=0; i<returnedFiles.length; i++){
        trow = document.createElement("tr");
        trow.setAttribute("tabindex", "0")
        
        trow.appendChild(linkCellHelper("td", (returnedFiles[i].Name), "Study%20Team", returnedFiles[i].Name));
        dateAdded = returnedFiles[i].TimeCreated.split("T")[1].replace("Z", "") + " on " + returnedFiles[i].TimeCreated.split("T")[0];
        trow.appendChild(textCellHelper("td", dateAdded));
        trow.appendChild(textCellHelper("td", returnedFiles[i].UIVersion)); //version //returnedFiles[i].UIVersion
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.Status)); //status
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.DateApproved)); //date approved
        trow.appendChild(textCellHelper("td", returnedFiles[i].ListItemAllFields.DocumentType)); //document type
//        if(readOnlyState == false){
//            trow.appendChild(buttonCellHelper("Remove", "removeAttachment('"+returnedFiles[i].Name+"', 'Study%20Team')"));
//        }
        
        trow.appendChild(buttonCellHelper("Remove", "removeAttachment('"+returnedFiles[i].Name+"', 'Study%20Team')"));
        trow.appendChild(buttonCellHelper("Update", "updateCurrentAttachment('"+returnedFiles[i].ListItemAllFields.ID+"')"));

        tbody.appendChild(trow);
    }

    table.appendChild(tbody);
    tableDiv.appendChild(table);
    container.appendChild(tableDiv);
    return container;
}

function triggerUpdateModal(){
	var modal, modalDialog, modalContent, modalHeader;
	var header, heading1, lineBreak, updateButton, closeButton, text, modalTitle, modalBody, modalFooter;
	var container, tableHeader, table, tableDiv, tbody, trow, trow2, dateAdded, cell;
	var statusTypes = ["Approved", "Changes Requested", "Submitted", "Under Review"];
	
	modal = document.createElement("div");
	modal.setAttribute("id", "updateModal");
	modal.setAttribute("class", "modal");
	
	modalDialog = document.createElement("div");
	modalDialog.setAttribute("role", "document");
	
	modalContent = document.createElement("div");
	modalContent.setAttribute("class", "modal-content");
	modalHeader = document.createElement("div");
	modalHeader.setAttribute("class", "modal-header");
	modalHeader.setAttribute("tabindex", "0");  //start tabbing on modal from header
	
	header = document.createElement("header");
	header.setAttribute("class", "modal-title");
	header.setAttribute("id", "modalTitle2");
	
	heading1 = document.createElement("H2");
	heading1.setAttribute("class", "modal-title");
	text = document.createTextNode("Update Document");
	heading1.appendChild(text);
	header.appendChild(heading1);
	modalHeader.appendChild(header);
	
	lineBreak = document.createElement("br");
	text = document.createTextNode("Please update the status of this document - "+currentAttachmentID+" - by selecting an option below.");
	
	modalFooter = document.createElement("div");
	modalFooter.setAttribute("class", "modal-footer");
	
	modalContent.appendChild(modalHeader);
	modalContent.appendChild(lineBreak);
	modalContent.appendChild(text);
	modalContent.appendChild(lineBreak);
	modalContent.appendChild(buildSelecterHelper("status", "Status", statusTypes, 12));
	modalContent.appendChild(lineBreak);

	
	/*Add Save Document Button*/
	updateButton = document.createElement("button");
	updateButton.setAttribute("class", "btn btn-sm modal-button"); //took out btn-info
	updateButton.setAttribute("data-dismiss", "updateModal")
	updateButton.setAttribute("aria-label", "Update");
	
	updateButton.setAttribute("title", "Update your document"); //hover tip
	updateButton.setAttribute("type", "button");
	updateButton.setAttribute("role", "button");
	updateButton.setAttribute("id", "updateModal");
	
    updateButton.setAttribute("onclick", "updateAttachment()");
	text = document.createTextNode("Update Document");
	updateButton.appendChild(text);
	
	/*Add Close Window Button*/
	closeButton = document.createElement("button");
	closeButton.setAttribute("class", "btn btn-sm modal-button modal-button-right");
	closeButton.setAttribute("data-dismiss", "modal");
	closeButton.setAttribute("aria-label", "Close");
	
	closeButton.setAttribute("title", "Close this window and return to the application"); //hover tip
	closeButton.setAttribute("type", "button");
	closeButton.setAttribute("role", "button");
	closeButton.setAttribute("id", "closeModal2");
	
	closeButton.setAttribute("onclick", "closeAttachmentUpdate()");
	text = document.createTextNode("Close this window");
	closeButton.appendChild(text);
	
	/*Combine Modal Elements*/
	modalFooter.appendChild(updateButton);
	modalFooter.appendChild(closeButton);
	modalContent.appendChild(modalFooter);
	modalDialog.appendChild(modalContent);
	modal.appendChild(modalDialog);
	$('body').append(modal);
	$('#updateModal').popup('show');
}

function updateCurrentAttachment(currentID){
	
	currentAttachmentID = currentID;
	triggerUpdateModal();
}
function closeAttachmentUpdate(){
	
	$('#updateModal').popup('hide'); 
	
	refreshDisplay('Files');
	
}


function facilityDisplay(returnedFacilities){
    var container, table, tableDiv, tbody, trow;
    var selectFacilities = [];
    var found;

    for(var i=0; i<returnedFacilities.length; i++){
        found = false;
        if(spAppData.CoordinatingSitesId != null){
        for(var j=0; j<spAppData.CoordinatingSitesId.results.length; j++){
            if(returnedFacilities[i].Id == spAppData.CoordinatingSitesId.results[j])
                found = true;
        }
        if(!found)
            selectFacilities.push(returnedFacilities[i].FacilityName);
        }else{
            selectFacilities.push(returnedFacilities[i].FacilityName);
        }
    }

    container = document.createElement("div");
    container.setAttribute("class", "form-content");

    /*Header Table*/
    table = tableHeaderHelper("Local Site Applications", ["Application", "Site Name", "Add/Remove"]);
    container.appendChild(table);

    /*Scrollable Body Table*/
    tableDiv = document.createElement("div");
    tableDiv.setAttribute("class", "div-table-content-big");

    table = document.createElement("table");
    table.setAttribute("class", "table table-striped table-hover");
    table.setAttribute("tabindex", "0");

    /*Table Body*/
    tbody = document.createElement("tbody");

    /*default row*/
    trow = document.createElement("tr");
    /****************************************/
    //need to look for applications in the 
    //specified coordinating site to see if 
    //the parent id's match this current id
    /****************************************/
    //trow.appendChild(buttonCellHelper("Local Site App", "generateLocalApp()"));
    trow.appendChild(textCellHelper("td", "No Application Available"));
    trow.appendChild(selectCellHelper("initAddFacility", "Select Facility to add", ["Please Select a Facility"].concat(selectFacilities), null));
    //trow.appendChild(textareaCellHelper("td", "initFacilityDescrip", "Facility Description"));
    trow.appendChild(buttonCellHelper("Add", "insertFacility('initAddFacility')"));
    tbody.appendChild(trow);

    for(var i=0; i<returnedFacilities.length; i++){
        for(var j=0; j<spAppData.CoordinatingSitesId.results.length; j++){
            if(returnedFacilities[i].Id == spAppData.CoordinatingSitesId.results[j]){
                trow = document.createElement("tr");

                //trow.appendChild(buttonCellHelper("Start Local Site Application", "generateLocalApp('"+returnedFacilities[i].Id+"')"));

                if((returnedFacilities[i].FacilityLiaisonId == currentUser.Id) && (targetStage > 1)){
                    if(childrenStudies.containsKey(returnedFacilities[i].Id)){
                        trow.appendChild(buttonCellHelper("View Application", "rerouteApp('"+(childrenStudies.get(returnedFacilities[i].Id)).Study_ID+"')"));
                    }else{
                        trow.appendChild(buttonCellHelper("Start Local Site Application", "generateLocalApp('"+returnedFacilities[i].Id+"')"));
                    }
                }else if((childrenStudies.containsKey(returnedFacilities[i].Id)) && ((childrenStudies.get(returnedFacilities[i].Id)).ApplicationStatus).indexOf("Approved") > -1){
                    trow.appendChild(buttonCellHelper("View Application", "rerouteApp('"+(childrenStudies.get(returnedFacilities[i].Id)).Study_ID+"')"));
                }else{
                    trow.appendChild(textCellHelper("td", "No Application Available"));
                }

                trow.appendChild(textCellHelper("td", returnedFacilities[i].FacilityName));
                trow.appendChild(buttonCellHelper("Remove", "removeFacility('"+returnedFacilities[i].Id+"', '"+returnedFacilities[i].FacilityLiaisonId+"')"));
                tbody.appendChild(trow);
            }
        }
    }


    table.appendChild(tbody);
    tableDiv.appendChild(table);
    container.appendChild(tableDiv);

    return container;
};

function generateLocalApp(facilityID){
    //console.log("generating local application");
    generateAssignedId("Local", facilityID);
};

function swapForNonVA(checkboxID, swapID){
    var tempList;
    var selectUsers = [];

    //remove drop down
    // $('#'+swapID).parent().children().remove();

    if($('#'+checkboxID).is(':checked')){
        $('#'+swapID).parent().replaceWith(textareaCellHelper("td", swapID, "Type in Non VA Person"));
    }else{
        tempList = ramsUsers.values()

        for(var i=0; i<tempList.length; i++){
            selectUsers.push(tempList[i].Title);
        }

        $('#'+swapID).parent().replaceWith(selectCellHelper(swapID, "Select Person to Add", selectUsers, null));
    }
}

function insertFacility(id){
    var facility = $('#'+id).val();
    //var facilities = spAppData.CoordinatingSitesId.results;
    //var liaisons;
    var data, liaisons, facilities;

    if(facility != "Please Select a Facility"){
        sendREST("GET", siteUrl.concat("_api/web/lists/getbytitle('Facility')/items"), null, function(json){
            var returnedFacilities = json.d.results;
            
            if(spAppData.CoordinatingSitesLiaisonId == null){
                liaisons = [];    
            }else{
                liaisons = spAppData.CoordinatingSitesLiaisonId.results;
            }

            if(spAppData.CoordinatingSitesId.results.length == 0){
                facilities = [];
            }else{
                //console.log("not null " + JSON.stringify(spAppData.CoordinatingSitesId));
                facilities = spAppData.CoordinatingSitesId.results;
            }

            for(var i=0; i<returnedFacilities.length; i++){
                if(returnedFacilities[i].FacilityName == facility){
                    facilities.push(returnedFacilities[i].Id);
                    liaisons.push(returnedFacilities[i].FacilityLiaisonId);

                    //console.log("we are sending: " + liaisons + " and " + facilities);

                    data = {
                        "__metadata": spAppData.__metadata,
                        "CoordinatingSitesId": {
                            "__metadata": { "type": "Collection(Edm.Int32)"},
                            "results": facilities
                        },
                        "CoordinatingSitesLiaisonId":{
                            "__metadata": {"type": "Collection(Edm.Int32)"},
                            "results": liaisons
                        }
                    }

                    spAppData.CoordinatingSitesId.results = facilities;
                    spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};

                    sendREST("POST", spAppData.__metadata.uri, data, function(){
                        if(spsubsiteAppData != null){
                            sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
                                refreshDisplay("Facility");
                            }, "Merge");
                        }else{
                            refreshDisplay("Facility");
                        }
                    }, "Merge");
                }
            }
        });
    }
}

function removeFacility(facilityID, liaisonID){
    var facilities = [];
    var liaisons = [];
    var data;
    //console.log("we recieved " + facilityID + " and " + liaisonID);

    //grab facilities from appData, identify which one you don't need and resend merge
    // sendREST("GET", siteUrl.concat("RAMSIRBSC/_api/web/lists/getbytitle('Facility')/items"), null, function(json){
    //     var returnedFacilities = json.d.results;
    //         for(var i=0; i<returnedFacilities.length; i++){
    //             if(returnedFacilities[i].Id == id){
                    for(var j=0; j<spAppData.CoordinatingSitesId.results.length; j++){
                        if(spAppData.CoordinatingSitesId.results[j] != facilityID)
                            facilities.push(spAppData.CoordinatingSitesId.results[j]);
                    }
                    for(var j=0; j<spAppData.CoordinatingSitesLiaisonId.results.length; j++){
                        //console.log("checking " + spAppData.CoordinatingSitesLiaisonId.results[j] + " vs " + liaisonID);
                        if(spAppData.CoordinatingSitesLiaisonId.results[j] != liaisonID){
                            //console.log("we want to keep: " + spAppData.CoordinatingSitesLiaisonId.results[j]);
                            liaisons.push(spAppData.CoordinatingSitesLiaisonId.results[j]);
                        }
                    }

                    if(liaisons.length >= 1){
                        data = {
                            "__metadata": spAppData.__metadata,
                            "CoordinatingSitesId": {
                                "__metadata": { "type": "Collection(Edm.Int32)"},
                                "results": facilities
                            },
                            "CoordinatingSitesLiaisonId":{
                                "__metadata": {"type": "Collection(Edm.Int32)"},
                                "results": liaisons
                            }                       
                        }     

                        spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};                    
                    }else{
                        //console.log("packaging empty data");
                        data = {
                            "__metadata": spAppData.__metadata,
                            "CoordinatingSitesId": {
                                "__metadata": { "type": "Collection(Edm.Int32)"},
                                "results": facilities
                            },
                            "CoordinatingSitesLiaisonId":{
                                "__metadata": {"type": "Collection(Edm.Int32)"},
                                "results": liaisons
                            }                                                 
                        }                        
                        spAppData.CoordinatingSitesLiaisonId = {"results" : liaisons};
                    }


                    spAppData.CoordinatingSitesId.results = facilities;
                    

                    //console.log("we are sending liaisons: " + liaisons + ", facilities: " + facilities);

                    sendREST("POST", spAppData.__metadata.uri, data, function(){
                        if(spsubsiteAppData != null){
                            sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
                                refreshDisplay("Facility");
                            }, "Merge");
                        }else{
                            refreshDisplay("Facility");
                        }
                    }, "Merge");
    //             }
    //         }
    // });
}

function insertPerson(){
    var inTable, capturedUser;

    if($('#initPerson').val() != "Please Select a User"){
        //check to see if person is in the sql table
        // if($('#initVA').is(':checked')){
        //     //person isn't in VA, needs to be added
        // }else{
        sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
            var foundUser = null;

            for(var j=0; j<returnedMembers.length; j++){
                if(returnedMembers[j].user.displayName == $('#initPerson').val()){
                    foundUser = returnedMembers[j];
                }
            }

            if(foundUser == null){
                sendREST("GET", restPath.concat("user"), null, function(returnedUsers){
                    for(var i=0; i<returnedUsers.length; i++){
                        //console.log("comparing: " + returnedUsers[i].displayName + " to " + $('#initPerson').val());
                        if(returnedUsers[i].displayName == $('#initPerson').val()){
                            sendPersonnelTable(returnedUsers[i]); 
                        }
                    }
                });                
            }else{
                sendPersonnelTable(foundUser.user, foundUser.study_MembersID);
            }
        });

        // }
    }else{
        insertWarning("You must first select a User before you can proceed.", "alert-warning");
    }
};

function sendPersonnelTable(foundUser, memberID){
    var data = {
        "study_MembersID": memberID,
        "user": foundUser,
        "vaUser": $('#initVA_0').is(':checked'),
        "teamMember": $('#initStudyTeam_0').is(':checked'),
        "memberRole": $('#initPersonRole').val(),
        "coiRequired": $('#initCOIReq_0').is(':checked'),
        "writePermissions": $('#initWritePerm_0').is(':checked'),
        "explaination": $('#initExplanation').val(),
        "notifications": $('#initNotify_0').is(':checked'),
        "activeMember": $('#initActivate_0').is(':checked')
    }
    //console.log("trying to send: " + JSON.stringify(data));
    //console.log("we are trying to add " + JSON.stringify(foundUser) + " with " + JSON.stringify(data));
    //sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+foundUser.usersID), data, function(){
    sendREST("POST", restPath.concat("study/"+assignedID+"/members/"), data, function(){        
        refreshDisplay('Personnel');
    });
}

function updatePerson(updateUser){
    if(updateUser == null){
        updateUser = $('#initPerson').val();
    }

    sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(returnedMembers){
        for(var i=0; i<returnedMembers.length; i++){
            if(returnedMembers[i].user.displayName == updateUser){
                //console.log("found our user: " + returnedMembers[i].user.displayName);
                
                //name
                $('#initPerson').val(returnedMembers[i].user.displayName);

                //on study team
                if(returnedMembers[i].teamMember){
                    $('#initStudyTeam_0').attr('checked', 'checked');
                }else{
                    $('#initStudyTeam_1').attr('checked', 'checked');
                }

                //role
                $('#initPersonRole').val(returnedMembers[i].memberRole);

                //COI
                if(returnedMembers[i].coiRequired){
                    $('#initCOIReq_0').attr('checked', 'checked');
                }else{
                    $('#initCOIReq_1').attr('checked', 'checked');
                }

                //read/write
                if(returnedMembers[i].writePermissions){
                    $('#initWritePerm_0').attr('checked', 'checked');
                }else{
                    $('#initWritePerm_1').attr('checked', 'checked');
                }

                //user explination
                $('#initExplanation').val(returnedMembers[i].explaination);

                //notifications
                if(returnedMembers[i].notifications){
                    $('#initNotify_0').attr('checked', 'checked');
                }else{
                    $('#initNotify_1').attr('checked', 'checked');
                }

                //activate
                if(returnedMembers[i].activeMember){
                    $('#initActivate_0').attr('checked', 'checked');
                }else{
                    $('#initActivate_1').attr('checked', 'checked');
                }
            }
        }
    })
};

function returnChecked(boolean){
    if(boolean){
        return textCellHelper("td", "x");
    }

    return textCellHelper("td", "");
}

function deactivateUser(usersID){
    sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+usersID+"/deactivate"), null, function(){
        refreshDisplay("Personnel");
    });
}

function activateUser(usersID){
    sendREST("POST", restPath.concat("study/"+assignedID+"/members/"+usersID+"/activate"), null, function(){
        refreshDisplay("Personnel");
    });
}

function removeAttachment(file, teamFolder){
    var data = [];
    var response = {};

    //console.log("looking to remove: " + file.split("-RAMS-")[0]);

    response = {
        "questionsID": file.split("-RAMS-")[0]
    };

    data.push(response);

    sendREST("POST", restPath.concat("study/"+assignedID+"/responses/"+targetStage), data, function(){
        sendREST("POST", siteUrl.concat("/_api/Web/GetFileByServerRelativeUrl('/sites/IRBApplications/Shared%20Documents/"+assignedID+"/"+teamFolder+"/"+file+"')"), null, function(){
            refreshDisplay("Files");
        }, "Delete");
    });
}

 function getAttachmentItem(itemID) {

        // Send the request and return the response.
        return jQuery.ajax({
            url: siteUrl.concat("/_api/Web/Lists/getByTitle('Shared Documents')/Items(" + itemID + ")"),
            type: "GET",
            headers: { "accept": "application/json;odata=verbose" }
        });
}

function updateAttachmentStatus(itemMetadata, docStatus) {

        // Define the list item changes. Use the FileLeafRef property to change the display name. 
        // For simplicity, also use the name as the title. 
        // The example gets the list item type from the item's metadata, but you can also get it from the
        // ListItemEntityTypeFullName property of the list.
		var item;
		var approvedDate = new Date();
        if (docStatus == "Approved"){
			item = {
			"__metadata": {"type": itemMetadata.type},
			"Status": docStatus,
			"DateApproved" : approvedDate
			};
		}
		else{
			
			item = {
			"__metadata": {"type": itemMetadata.type},
			"Status": docStatus
			};
		}

        // Send the request and return the promise.
        // This call does not return response content from the server.
        return jQuery.ajax({
            url: itemMetadata.uri,
            type: "POST",
            data: JSON.stringify(item),
            headers: {
                "X-RequestDigest": requestDigest,
                "content-type": "application/json;odata=verbose",
                "IF-MATCH": itemMetadata.etag,
                "X-HTTP-Method": "MERGE"
            }
        });
}
function updateAttachment() {
	var docStatus =  $('#status').find(':selected').val();
    var now = new Date();
	var attachmentItem = getAttachmentItem(currentAttachmentID);
	attachmentItem.done(function (listItem, status, xhr) {

			// Change the display name and title of the list item.
			var changeItem = updateAttachmentStatus(listItem.d.__metadata, docStatus);
			changeItem.done(function (data, status, xhr) {
				alert('Attachment status updated');
			});
			changeItem.fail(function (data, status, xhr) {
				alert('file uploaded failed:' + status);
			});
	});
	attachmentItem.fail(function (data, status, xhr) {
				alert('get attachment item failed' + status);
	});
    
	
	

}

function rerouteApp(childId){
    window.location.href("irb-applications-general.html?" + childId);
}
